public class Giocatore implements Contenitore, Mobile
{
	protected Contenitore luogo;
	protected String nome;
	protected final static int MAX_OGGETTI = 10;
	protected Oggetto[] oggetti;
	protected int num_oggetti;
	public Giocatore(String n, Contenitore l)
	{
		nome = n;
		if (l != null)
		{
			l.aggiungi(this);
			luogo = l;
		}
		oggetti = new Oggetto[MAX_OGGETTI];
		num_oggetti = 0;
	}
	public String nome()
	{
		return nome;
	}
	public Contenitore luogo()
	{
		return luogo;
	}
	public Risultato sposta(
			Contenitore sorg, Contenitore dest)
	{
		if (sorg != luogo)
			return new Risultato(
					false, nome + " si e' spostato.");
		Risultato r;
		if (luogo != null)
		{
			r = luogo.rimuovi(this);
			if (!r.isOk())
				return r;
		}
		r = dest.aggiungi(this);
		if (!r.isOk())
		{
			luogo.aggiungi(this);
			return r;
		}
		luogo = dest;
		return new Risultato();
	}
	public Risultato aggiungi(Oggetto o)
	{
		for (int i = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] == null)
			{
				oggetti[i] = o;
				num_oggetti++;
				return new Risultato();
			}
		}
		return new Risultato(false, "Non c'e' piu' posto.");
	}
	public Risultato rimuovi(Oggetto o)
	{
		for (int i = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] == o)
			{
				oggetti[i] = null;
				num_oggetti--;
				return new Risultato();
			}
		}
		return new Risultato(false, "Non vedo " + o.nome());
	}
	public Oggetto[] elenco()
	{
		Oggetto[] tmp = new Oggetto[num_oggetti];
		for (int i = 0, j = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] != null)
				tmp[j++] = oggetti[i];
		}
		return tmp;
	}
}
