public class Stanza implements Contenitore
{
	protected String descr;
	protected Porta[] porte = new Porta[4];
	protected final static int MAX_OGGETTI = 10;
	protected Oggetto[] oggetti;
	protected int num_oggetti;
	public Stanza(String descr)
	{
		this.descr = descr;
		oggetti = new Oggetto[MAX_OGGETTI];
		num_oggetti = 0;
	}
	public void collega(int dir, Porta porta)
	{
		porte[dir] = porta;
	}
	public Risultato vai(Giocatore giocatore, int dir)
	{
		if (porte[dir] == null)
			return new Risultato(
					false, "Non puoi andare in quella direzione");
		else
			return porte[dir].attraversa(giocatore);
	}
	public String descrivi()
	{
		return descr;
	}
	public int[] direzioni()
	{
		int num = 0;
		for (int d = 0; d < 4; d++)
			if (porte[d] != null)
				num++;
		int[] dir = new int[num];
		int i = 0;
		for (int d = 0; d < 4; d++)
			if (porte[d] != null)
			{
				dir[i] = d;
				i++;
			}
		return dir;
	}
	public Risultato aggiungi(Oggetto o)
	{
		for (int i = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] == null)
			{
				oggetti[i] = o;
				num_oggetti++;
				return new Risultato();
			}
		}
		return new Risultato(false, "Non c'e' piu' posto.");
	}
	public Risultato rimuovi(Oggetto o)
	{
		for (int i = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] == o)
			{
				oggetti[i] = null;
				num_oggetti--;
				return new Risultato();
			}
		}
		return new Risultato(false, "Non vedo " + o.nome());
	}
	public Oggetto[] elenco()
	{
		Oggetto[] tmp = new Oggetto[num_oggetti];
		for (int i = 0, j = 0; i < MAX_OGGETTI; i++)
		{
			if (oggetti[i] != null)
				tmp[j++] = oggetti[i];
		}
		return tmp;
	}
}
